// !! only works with linear LUTs
// will switch all LUTs between inverted and non inverted 
// and switch the new composite rendering mode accordingly
// Author: Kevin Terretaz

    requires("1.53o");
    getDimensions(width, height, channels, slices, frames);
    REDS = newArray(256); GREENS = newArray(256); BLUES = newArray(256);
    for (c = 1; c <= channels; c++) {
        if (is("composite")) Stack.setChannel(c);
        getLut(reds,greens,blues);
        RED = reds[255]; GREEN = greens[255]; BLUE = blues[255];
        // if grayscale just invert
        if (RED==GREEN && RED==BLUE) {
            run("Invert LUT");
            break;
        }
        // if already inverted LUT, revert it back :
        else if (is("Inverting LUT")) {
            for(i=0; i<256; i++) { 
                REDS[i]   = (RED/256)*(i+1);
                GREENS[i] = (GREEN/256)*(i+1);
                BLUES[i]  = (BLUE/256)*(i+1);
            }
        }
        else {
            //make inverted LUT
            REDS = newArray(256); GREENS = newArray(256); BLUES = newArray(256);
            for (i=0; i<256; i++) { 
                REDS[i]   = 255-(((256-RED)/256)*i);
                GREENS[i] = 255-(((256-GREEN)/256)*i);
                BLUES[i]  = 255-(((256-BLUE)/256)*i);
            }
        }
        setLut(REDS, GREENS, BLUES);
    }
    // CompositeProjection mode switch :
    if (Property.get("CompositeProjection") == "Min")
       Property.set("CompositeProjection", "");
    else
       Property.set("CompositeProjection", "Min");
    updateDisplay();
    
